import numpy as np
from scipy.ndimage import gaussian_filter
import math
import sys
import random
import matplotlib
import matplotlib.pyplot as plt
matplotlib.use("Agg")

def read_image(infile):

    with open(infile, 'rb') as f1:
       image = np.fromfile(f1, dtype=np.float64)

       ## normalize data
       #image = Rescaling(1/255, 0.0, "rescaling")(image)
       #image = np.clip(image/np.amax(image),0.0,None)
       print(np.amin(image),np.amax(image))

    return [np.array(image,dtype=np.float64)]

# 12/07/19
#refvalues = ([0.013034,0.024206,0.040278,0.077616,0.11809,0.182476,0.238336,0.297136,0.346822,0.419636,0.47138,0.575358,0.634354,0.708442,0.76097,0.873474,0.98833,1.16718,1.29801,1.404438,1.880032])
# 18/08/17
refvalues = ([0.0000, 0.0199, 0.0374, 0.0580, 0.0746, 0.0992, 1.1780, 0.1249, 0.1755, 0.2127, 0.2545, 0.3189, 0.4106, 0.5416, 0.7088])
# 21/01/20
#refvalues = ([1.0329, 1.2153, 1.4229, 0.1422, 1.8228, 0.2065, 0.2803, 0.0244, 0.3328, 0.4142, 0.5566, 0.6644, 0.0641, 0.8193, 0.0917])

#inputdir ='/m100_scratch/userexternal/nsanvita/temp/'
#inputdir ='/m100_scratch/userexternal/nsanvita/exp_data/180817_oldled/'
#inputdir ='/m100_scratch/userexternal/nsanvita/exp_data/180817_oldled_10mm_64px/'
inputdir = '/m100_scratch/userexternal/nsanvita/exp_data/new_led_21-01-2020/'
#inputdir = '/m100_scratch/userexternal/nsanvita/exp_data/180817_oldled_10mm_16px/'
#inputdir = '/m100_scratch/userexternal/nsanvita/exp_data/180817_oldled_10mm_128px/'
for img in range(1,16):
 infile = inputdir+'particleone_synth_'+str(img)+'.bin'
 print(infile)
 numberofimages = 1
 resolution_y = 32
 resolution_x = 32

 if resolution_x == 32:
    edge_radius = 15.5
    edge_brightness = 0.25
##new 1
#    sigmanoise = 0.090
#    background = -0.2
#    sigmabackground = 0.0
#version 4
    sigmanoise = 0.055
    background = 0.2
    sigmabackground = 0.05
#    
    writeimages = 1
    remove_external_values = 1
    sigmablur = 1.0
    fth = 0.25
 if resolution_x == 64:
    edge_radius = 31
    edge_brightness = 0.25
    sigmanoise = 0.080
    sigmablur = 1.2
    background = -0.2
    sigmabackground = 0.0
    writeimages = 1
    remove_external_values = 1
    fth = 0.25
 if resolution_x == 16:
    edge_radius = 7.5
    edge_brightness = 0.25
    sigmanoise = 0.025
    sigmablur = 0.75
    background = -0.2
    sigmabackground = 0.0
    writeimages = 1
    remove_external_values = 1
    fth = 0.25
 if resolution_x == 128:
    edge_radius = 62
    edge_brightness = 0.25
    sigmanoise = 0.095
    sigmablur = 2.0
    background = -0.2
    sigmabackground = 0.0
    writeimages = 1
    remove_external_values = 1
    fth = 0.25

 images = np.zeros((numberofimages,resolution_y,resolution_x))
 images_orig = np.zeros((numberofimages,resolution_y,resolution_x))

 image = read_image(infile)

 index = 0
 images[index,:,:] = np.reshape(image,(resolution_y,resolution_x))
 images_orig[index,:,:] = images[index,:,:]
 refvalue = refvalues[index]

        # Add edge
 if edge_radius > 0:
           for ii in range(resolution_y):
                for jj in range(resolution_x):
                    dist = math.sqrt((ii-0.5*resolution_y)**2 + (jj-0.5*resolution_x)**2)
                    if dist <= edge_radius and dist >= edge_radius-1:
                       edge_int = random.uniform(edge_brightness-0.1,edge_brightness+0.1)
                       images[index,ii,jj] = edge_int
        # Remove edge
 if edge_radius < 0:
           edge_radius_abs = abs(edge_radius)
           for ii in range(resolution_y):
                for jj in range(resolution_x):
                    dist = math.sqrt((ii-0.5*resolution_y)**2 + (jj-0.5*resolution_x)**2)
                    if dist > edge_radius_abs:
                       images[index,ii,jj] = 0.0

        # Add gaussian noise
 if sigmanoise > 0:
            dirtyimg = np.empty_like(images[index,:,:])
            dirtyimg = np.random.normal(loc=0.0, scale=sigmanoise, size=dirtyimg.shape)
            images[index,:,:] = np.clip(dirtyimg[:,:] + images[index,:,:], 0, 1)
            ###images[index,:,:] = images[index,:,:]+background

        # Add background
 if background > 0.0:
            background0  = (background/fth)*refvalue
            if refvalue > fth:
             background0  = background
            dirtyimg = np.random.normal(loc=background0 , scale=sigmabackground, size=dirtyimg.shape)
            images[index,:,:] = np.clip(dirtyimg[:,:] + images[index,:,:], 0, 1)

        # Add gaussian blur
 if sigmablur > 0:
            dirtyimg = np.empty_like(images[index,:,:])
            gaussian_filter(input=images[index,:,:],sigma=sigmablur,output=dirtyimg,mode='constant',cval=0.0,truncate=4.0)
            print("max ",np.max(images[index,:,:]),np.max(dirtyimg))
            images[index,:,:] = dirtyimg

 if remove_external_values == 1:
            edge_radius_abs = abs(edge_radius)+1
            for ii in range(resolution_y):
                for jj in range(resolution_x):
                    dist = math.sqrt((ii-0.5*resolution_y)**2 + (jj-0.5*resolution_x)**2)
                    if dist > edge_radius_abs:
                       images[index,ii,jj] = 0.0

# write bin image
 infile = "bin/noise_newback_vs4_"+str(img)+".bin"
 f1 = open(infile, 'wb')
 f1.write(images[index,:,:])
 f1.close()

# write png images
 if writeimages == 1:
            dpi = 1
            height = images[index,:,:].shape[0]
            width = images[index,:,:].shape[1]
            fig = plt.figure(figsize=(width, height),dpi=dpi)
            ax = fig.add_axes([0, 0, 1, 1])
            ax.axis('off')
            ax.imshow(images[index,:,:], cmap='gray', interpolation='none')
            testfilename = "images/noise"+str(img)+".png"
            fig.savefig(testfilename,dpi=dpi)
            ax.imshow(images_orig[index,:,:], cmap='gray', interpolation='none')
            testfilename = "images/orig"+str(img)+".png"
            fig.savefig(testfilename,dpi=dpi)

