import numpy as np
import matplotlib.pyplot as plt

import tensorflow as tf
config = tf.compat.v1.ConfigProto()
config.gpu_options.allow_growth = True
sess = tf.compat.v1.Session(config=config)
from tensorflow import keras
from inputparameters import *
from  load_data_Images import *
import glob
import math
import sys
import time
from tensorflow.keras.optimizers import Adam
from tensorflow.keras.wrappers.scikit_learn import KerasRegressor
from cnnmodel import *
import argparse

parser = argparse.ArgumentParser()
parser.add_argument('--hyper_file', type=str, help='Read the hyperparameter file')
args = parser.parse_args()
restartfile_evaluate = args.hyper_file
print(restartfile_evaluate)

go = 1
time0 = time.time()
if go == 1:

     # Load data
     trainXNoisy, trainsize = load_data_Images(seed,comm,0)
     trainXNoisy = np.expand_dims(trainXNoisy, axis=-1)
     timemodel1 = time.time()

     # Load network
     cnn = keras.models.load_model(restartfile_evaluate)
     cnn.summary()
     timemodel2 = time.time()
     timemodel = timemodel2-timemodel1

     # Calculate forces
     timeeval1 = time.time()
     y_pred = cnn.predict(trainXNoisy)
     timeeval2 = time.time()
     timeeval = timeeval2-timeeval1

     #regressor = KerasRegressor(build_fn=cnn)
     #regressor.fit(trainXNoisy, trainX)
     #predicted_values = regressor.predict(trainXNoisy)

     # Error statistics
     if startcontact == 2:
      err = 0.0
      err_abs = 0.0
      f = open('test.txt','w')
      for j in range(y_pred.shape[0]):
        for i in range(y_pred.shape[1]):
             f.write(str(j)+' '+str(i)+' '+str(y_pred[j,i])+'\n')
        if refvalues[j] > 0.0:
           print("Disk %3d:\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f" % (j,refvalues[j],y_pred[j,0],y_pred[j,1],y_pred[j,0]-refvalues[j],abs(y_pred[j,0]-refvalues[j])/refvalues[j]))
           err = err + abs(y_pred[j,0]-refvalues[j])/refvalues[j]
           err_abs = err_abs + abs(y_pred[j,0]-refvalues[j])
        else:
           print("Disk %3d:\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f" % (j,refvalues[j],y_pred[j,0],y_pred[j,1],y_pred[j,0]-refvalues[j],abs(y_pred[j,0]-refvalues[j])))

        f.write(' \n')
      f.close()
     
     if startcontact == 3:
      err = 0.0
      err_abs = 0.0
      print("Disk id\t\tRef\tCalc\terror\trel err")
      for j in range(y_pred.shape[0]):
        #print(y_pred[j,0], y_pred[j,1], y_pred[j,2])
        f1 = max([y_pred[j,0], y_pred[j,1], y_pred[j,2]])
        if refvalues[j] > 0.0:
          print("Disk %3d:\t%5.3f\t%5.3f\t%5.3f\t%5.3f" % (j,refvalues[j],f1,f1-refvalues[j],abs(f1-refvalues[j])/refvalues[j]))
          err = err + abs(f1-refvalues[j])/refvalues[j]
          err_abs = err_abs + abs(f1-refvalues[j])
        else:
          print("Disk %3d:\t%5.3f\t%5.3f\t%5.3f\t%5.3f" % (j,refvalues[j],f1,f1-refvalues[j],abs(f1-refvalues[j])))


     err = err/(y_pred.shape[0]-1)
     err_abs = err_abs/(y_pred.shape[0]-1)
     print()
     print('Average percentage error:',err)
     print('Average absolute error:',err_abs)


     print("Timings: ",timemodel,timeeval)
