import numpy as np
import matplotlib.pyplot as plt

import tensorflow as tf
config = tf.compat.v1.ConfigProto()
config.gpu_options.allow_growth = True
sess = tf.compat.v1.Session(config=config)
from tensorflow import keras
from inputparameters import *
from  load_data import *
import glob
import math
import sys
import time
from tensorflow.keras.optimizers import Adam
from tensorflow.keras.wrappers.scikit_learn import KerasRegressor
from cnnmodel import *
import argparse

parser = argparse.ArgumentParser()
parser.add_argument('--hyper_file', type=str, help='Read the hyperparameter file')
args = parser.parse_args()
restartfile_evaluate = args.hyper_file
print(restartfile_evaluate)

go = 1
with tf.compat.v1.Session(config=config) as sess:
  if go == 1:
     trainXNoisy, testXNoisy, trainX, testX, trainsize, testsize = load_data(seed,comm,29000)
     trainXNoisy = np.expand_dims(trainXNoisy, axis=-1)
     testXNoisy = np.expand_dims(testXNoisy, axis=-1)

     cnn = keras.models.load_model(restartfile_evaluate)
     cnn.summary()

     #opt = Adam(lr=0.7)
     #cnn.compile(optimizer=opt, loss="mean_squared_error",metrics=["mean_squared_error"])
     y_pred = cnn.predict(trainXNoisy)

     #regressor = KerasRegressor(build_fn=cnn)
     #regressor.fit(trainXNoisy, trainX)
     #predicted_values = regressor.predict(trainXNoisy)

     toll = 0.05
     error = 0.0
     error_sq = 0.0
     error_perc = 0.0
     count = 0.0
     count_perc = 0.0
     f = open('test.txt','w')
     for j in range(y_pred.shape[0]):
        for i in range(y_pred.shape[1]):
             error = error+abs(y_pred[j,i]-trainX[j,i])
             if abs(trainX[j,i]) > toll:
                error_perc = error_perc+abs((y_pred[j,i]-trainX[j,i])/trainX[j,i])
                count_perc = count_perc+1.0
             error_sq = error_sq+(y_pred[j,i]-trainX[j,i])**2
             f.write(str(y_pred[j,i])+' '+str(trainX[j,i])+'\n')
             count = count+1.0
             #print(y_pred[j,i],trainX[j,i])
     f.close()
     print('ABS ERROR  = ',error/count)
     print('RMS ERROR  = ',error_sq/count)
     print('PERC ERROR = ',error_perc/count_perc)

     Xflatten = trainX.flatten()
     Yflatten = y_pred.flatten()
     z = np.polyfit(Xflatten,Yflatten, 1, full=False)
     #corr_matrix = np.corrcoef(trainX, y_pred)
     #corr = corr_matrix[0,1]
     #R_sq = corr**2
     
     f = open('stat.txt','w')
     f.write(str(error/count)+' '+str(error_sq/count)+' '+str(error_perc/count_perc)+' '+str(z[0])+' '+str(z[1])+'\n')
     f.close()
     print("coeff. ang. = ",z[0],"  intercept = ",z[1])
     plt.scatter(trainX, y_pred,s=1)
     #plt.xlim(-0.05,1)
     #plt.ylim(-0.05,1)
     plt.xlim(-0.05,3.20)
     plt.ylim(-0.05,3.20)
     #plt.ylim(-1.57,1.57)
     #plt.xlim(-1.57,1.57)
     plt.title("Beta")
     plt.xlabel('True value')
     plt.ylabel('Est. value')
     dpi=100
     plt.savefig('test.png',dpi=dpi)
